<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button class="btn btn-primary ml-1" (click)="buscarInfo()" [disabled]="loading || ngForm.invalid">
    <i class="fa fa-search mr-2"></i>Buscar
  </button>
  <button (click)="exportExcel()" class="btn btn-success ml-1" [disabled]="loading || !dataGrid.length">
    <i class="fa fa-file-excel mr-2"></i>Excel
  </button>
</app-page-title>

<div class="card">
  <div class="card-body">

    <form [formGroup]="ngForm">

      <div class="row">
        <div class="col-6 col-sm-6 col-md-3 col-lg-3 col-xl-3 form-group">
          <label class="w-100">Agencia</label>
          <div class="input-group">
            <input type="text" class="form-control" formControlName="cChr2" appFocus>
            <div class="input-group-append">
              <button class="btn btn-primary" (click)="openModal(modalAgencia)">
                <i class="fas fa-search"></i>
              </button>
            </div>
          </div>
        </div>

        <div class="form-group col-12 col-sm-3 col-md-3 col-lg-3 col-xl-3">
          <label class="w-100">Desde</label>
          <kendo-datepicker formControlName="fFec1" (valueChange)="fechaDesdeChange()" [max]="maxDateDesde"
            class="w-100" [format]="formatKendo">
          </kendo-datepicker>
        </div>
        <div class="form-group col-12 col-sm-3 col-md-3 col-lg-3 col-xl-3">
          <label class="w-100">Hasta</label>
          <kendo-datepicker formControlName="fFec2" [min]="minDateHasta" [max]="maxDateHasta" class="w-100"
            [format]="formatKendo" (valueChange)="fechaHastaChange()">
          </kendo-datepicker>
        </div>
        <div class="col-xl-2 col-lg-2 col-md-2 col-sm-6">
          <label class="k-form-field ml-sm-2 mt-2">
            <label></label>
            <input type="checkbox" id="lLog1" class="k-checkbox mt-2" formControlName="lLog1">
            <label class="k-checkbox-label mt-4" for="lLog1">Imprime esta empresa</label>
          </label>
        </div>
      </div>
    </form>

    <div class="divider"></div>

    <kendo-grid [kendoGridBinding]="dataGrid" *ngIf="!loading" [selectable]="true" [filter]="filter" [filterable]="true"
      [navigable]="true" [reorderable]="true" [resizable]="true" [sortable]="true"
      [pageSize]="pageSize" [skip]="skip" [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}" style="height: 60vh;">
      <div *ngIf="dataGrid.length !== 0">
        <kendo-grid-column field="Agencia" title="Agencia" width="130">
        </kendo-grid-column>
        <kendo-grid-column field="Fecha" title="Fecha" width="120">
          <ng-template kendoGridCellTemplate let-dataItem>
            {{ dataItem.Fecha | date: formatKendo }}
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="Hora" title="Hora" width="130">
          <ng-template kendoGridCellTemplate let-dataItem>
            {{ dataItem.Hora | hour }}
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="Tipo" title="Tipo" width="130">
        </kendo-grid-column>
        <kendo-grid-column field="Ope" title="Operador" width="130">
        </kendo-grid-column>
        <kendo-grid-command-column width="100">
          <ng-template kendoGridCellTemplate let-dataItem>
            <button class="btn btn-primary ml-1" id="{{dataItem}}" (click)="openModal(modal, dataItem);">
              <i class="fa fa-search mr-2"></i>Ver
            </button>
          </ng-template>
        </kendo-grid-command-column>
      </div>
      <ng-template kendoGridNoRecordsTemplate>
        {{ noRecords }}
      </ng-template>
    </kendo-grid>

  </div>
  <app-loading *ngIf="loading"></app-loading>
</div>


<ng-template #modal let-modal let-c="close">
  <div class="modal-header">
    <h6 class="modal-title" id="modal-graf">Revisión de Cambios</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <div class="row">
      <div class="col-6 col-sm-6 col-md-4 col-lg-4 form-group">
        <label class="w-100">Nombre</label>
        <input type="text" class="form-control form-control-sm" value="{{selectedItem.Nombre}}" readonly>
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-4 form-group">
        <label class="w-100">R.F.C.</label>
        <input type="text" class="form-control form-control-sm" value="{{selectedItem.rfc}}" readonly>
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-4 form-group">
        <label class="w-100">E-Mail</label>
        <input type="text" class="form-control form-control-sm" value="{{selectedItem.Email}}" readonly>
      </div>

      <div class="row-fluid col-6 col-sm-6 col-md-4 col-lg-4">
        <label class="w-100">Contactos</label>
        <ng-container *ngFor="let item of selectedItem.Contacto">
          <div class="form-group">
            <input type="text" class="form-control form-control-sm" [value]="item" readonly>
          </div>
        </ng-container>
      </div>
      <div class="row-fluid col-6 col-sm-6 col-md-4 col-lg-4">
        <label class="w-100">Puestos</label>
        <ng-container *ngFor="let item of selectedItem.Puesto">
          <div class="form-group">
            <input type="text" class="form-control form-control-sm" [value]="item" readonly>
          </div>
        </ng-container>
      </div>
      <div class="row-fluid col-6 col-sm-6 col-md-4 col-lg-4">
        <label class="w-100">e-mails</label>
        <ng-container *ngFor="let item of selectedItem.EmailContacto">
          <div class="form-group">
            <input type="text" class="form-control form-control-sm" [value]="item" readonly>
          </div>
        </ng-container>
      </div>

      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Dirección</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Direccion[0]}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Colonia</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Direccion[1]}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Ciudad</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Ciudad}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Estado</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Estado}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">C.P.</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.CodigoPostal}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Sucursal</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Sucursal}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Teléfonos</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Telefono[0]}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100 mt-2"></label>
        <input type="text" class="form-control form-control-sm mt-2" value="{{selectedItem.Telefono[1]}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Fax</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Fax}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Top</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Top ? 'Si' : 'No'}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Clasificación</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Clasificacion}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Cond.</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Tipo}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Allotment</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Control ? 'Si' : 'No'}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">T.R.</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.treser}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Segmento</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Segmento}}">
      </div>
      <div class="col-8 form-group">
        <label class="w-100">Notas</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Notas}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">IATA</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.IATA}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">F.P.</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.FP}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Origen</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Origen}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Cobranza</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Cobranza}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Inactivo</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Inactivo ? 'Si' : 'No'}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Factura</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.Fact}}">
      </div>
      <div class="col-6 col-sm-6 col-md-4 col-lg-3 form-group">
        <label class="w-100">Refacturar</label>
        <input type="text" class="form-control form-control-sm" readonly value="{{selectedItem.lFactura ? 'Si' : 'No'}}">
      </div>
    </div>
  </div>
  <div class="modal-footer">
    <button class="btn btn-secondary" (click)="c('Close click')">Cerrar</button>
  </div>
</ng-template>

<ng-template #modalAgencia let-modal let-c="close">
  <div class="modal-header">
    <h6 class="modal-title" id="modal-graf">Buscar Agencia</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <app-help-agencia (agencia)="resultAgencia($event); c();"></app-help-agencia>
  </div>
  <div class="modal-footer">
    <button class="btn btn-secondary" (click)="c('Close click')">Cerrar</button>
  </div>
</ng-template>